library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity external_memory_32 is
  port (
    clk : in std_logic;
    reset : in std_logic;
    data_length : out signed(32-1 downto 0);
    data_address : in signed(32-1 downto 0);
    data_din : in signed(32-1 downto 0);
    data_dout : out signed(32-1 downto 0);
    data_we : in std_logic;
    data_oe : in std_logic;
    ext_length : in signed(32-1 downto 0);
    ext_address : out signed(32-1 downto 0);
    ext_din : out signed(32-1 downto 0);
    ext_dout : in signed(32-1 downto 0);
    ext_we : out std_logic;
    ext_oe : out std_logic
  );
end external_memory_32;

architecture RTL of external_memory_32 is

  attribute mark_debug : string;
  attribute keep : string;
  attribute S : string;


  signal clk_sig : std_logic;
  signal reset_sig : std_logic;
  signal data_length_sig : signed(32-1 downto 0);
  signal data_address_sig : signed(32-1 downto 0);
  signal data_din_sig : signed(32-1 downto 0);
  signal data_dout_sig : signed(32-1 downto 0);
  signal data_we_sig : std_logic;
  signal data_oe_sig : std_logic;
  signal ext_length_sig : signed(32-1 downto 0);
  signal ext_address_sig : signed(32-1 downto 0);
  signal ext_din_sig : signed(32-1 downto 0);
  signal ext_dout_sig : signed(32-1 downto 0);
  signal ext_we_sig : std_logic;
  signal ext_oe_sig : std_logic;


begin

  clk_sig <= clk;
  reset_sig <= reset;
  data_length <= data_length_sig;
  data_length_sig <= ext_length_sig;

  data_address_sig <= data_address;
  data_din_sig <= data_din;
  data_dout <= data_dout_sig;
  data_dout_sig <= ext_dout_sig;

  data_we_sig <= data_we;
  data_oe_sig <= data_oe;
  ext_length_sig <= ext_length;
  ext_address <= ext_address_sig;
  ext_address_sig <= data_address_sig;

  ext_din <= ext_din_sig;
  ext_din_sig <= data_din_sig;

  ext_dout_sig <= ext_dout;
  ext_we <= ext_we_sig;
  ext_we_sig <= data_we_sig;

  ext_oe <= ext_oe_sig;
  ext_oe_sig <= data_oe_sig;


  -- expressions

  -- sequencers



end RTL;
